-- ********************************
--        CREATE AUTH TABLES
-- ********************************

CREATE TABLE CATEGORY_DATASET
(
	CAT_ID BIGINT NOT NULL,
	DS_ID BIGINT NOT NULL,
	PRIMARY KEY (CAT_ID, DS_ID),
	KEY (CAT_ID),
	KEY (DS_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE CATEGORY_DB_CONNECTION
(
	CAT_ID BIGINT NOT NULL,
	CONNECTION_ID BIGINT NOT NULL,
	PRIMARY KEY (CAT_ID, CONNECTION_ID),
	KEY (CAT_ID),
	KEY (CONNECTION_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE CATEGORY_USER
(
	CAT_ID BIGINT NOT NULL,
	USER_ID BIGINT NOT NULL,
	PRIMARY KEY (CAT_ID, USER_ID),
	KEY (CAT_ID),
	KEY (USER_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE DATAFLOW_DATASET
(
	DF_ID BIGINT NOT NULL,
	DS_ID BIGINT NOT NULL,
	PRIMARY KEY (DF_ID, DS_ID),
	KEY (DF_ID),
	KEY (DS_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE DATAFLOW_DB_CONNECTION
(
	DF_ID BIGINT NOT NULL,
	CONNECTION_ID BIGINT NOT NULL,
	PRIMARY KEY (DF_ID, CONNECTION_ID),
	KEY (DF_ID),
	KEY (CONNECTION_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE DATAFLOW_USER
(
	DF_ID BIGINT NOT NULL,
	USER_ID BIGINT NOT NULL,
	PRIMARY KEY (DF_ID, USER_ID),
	KEY (DF_ID),
	KEY (USER_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE DB_VERSION
(
	SYS_ID BIGINT NOT NULL AUTO_INCREMENT,
	VERSION NVARCHAR(255) NOT NULL,
	PRIMARY KEY (SYS_ID, VERSION)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE MA_USER
(
	USER_ID BIGINT NOT NULL AUTO_INCREMENT,
	USERNAME NVARCHAR(255) NOT NULL,
	PASSWORD NVARCHAR(255),
	USER_TYPE SMALLINT,
	PRIMARY KEY (USER_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

-- ************************************
--        CREATE HEADER TABLES
-- ************************************

CREATE TABLE CONTACT_DETAIL
(
	CD_ID BIGINT NOT NULL AUTO_INCREMENT,
	CONTACT_ID BIGINT,
	TYPE VARCHAR(50),
	VALUE VARCHAR(255),
	PRIMARY KEY (CD_ID),
	KEY (CONTACT_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


CREATE TABLE CONTACT
(
	CONTACT_ID BIGINT NOT NULL AUTO_INCREMENT,
	PARTY_ID BIGINT,
	PRIMARY KEY (CONTACT_ID),
	KEY (PARTY_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


CREATE TABLE HEADER_LOCALISED_STRING
(
	HLS_ID BIGINT NOT NULL AUTO_INCREMENT,
	TYPE VARCHAR(50),
	HEADER_ID BIGINT,
	PARTY_ID BIGINT,
	CONTACT_ID BIGINT,
	LANGUAGE VARCHAR(50),
	TEXT VARCHAR(255),
	PRIMARY KEY (HLS_ID),
	KEY (CONTACT_ID),
	KEY (HEADER_ID),
	KEY (PARTY_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


CREATE TABLE PARTY
(
	PARTY_ID BIGINT NOT NULL AUTO_INCREMENT,
	ID VARCHAR(255),
	HEADER_ID BIGINT,
	TYPE NVARCHAR(50),
	PRIMARY KEY (PARTY_ID),
	KEY (HEADER_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


CREATE TABLE HEADER
(
	HEADER_ID BIGINT NOT NULL AUTO_INCREMENT,
	TEST BOOL,
	DATASET_AGENCY NVARCHAR(255),
	DF_ID BIGINT,
	PRIMARY KEY (HEADER_ID),
	KEY (DF_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


-- *************************
--        ALTERATIONS
-- *************************
ALTER TABLE DB_CONNECTION 
DROP COLUMN CAT_ID,	-- now there is a N-N table for this
DROP COLUMN OWNER,	-- now there is a FK for this (see below)
ADD COLUMN USER_ID BIGINT(20) AFTER JDBC_CONNECTION_STRING
;
 
ALTER TABLE MAPPING_SET 
ADD COLUMN USER_ID BIGINT(20) AFTER DF_ID
;

ALTER TABLE DATASET 
ADD COLUMN USER_ID BIGINT(20) AFTER XML_QUERY
;

-- ************************
--        AUTH CONSTRAINTS
-- ************************
-- The two fields of CATEGORY_DATASET are FKs
ALTER TABLE CATEGORY_DATASET ADD CONSTRAINT FK_CATEGORY_DATASET_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
	ON DELETE CASCADE
;
-- The two fields of CATEGORY_DATASET are FKs
ALTER TABLE CATEGORY_DATASET ADD CONSTRAINT FK_CATEGORY_DATASET_DATASET 
	FOREIGN KEY (DS_ID) REFERENCES DATASET (DS_ID)
	ON DELETE CASCADE
;
-- The two fields of CATEGORY_DB_CONNECTION are FKs
ALTER TABLE CATEGORY_DB_CONNECTION ADD CONSTRAINT FK_CATEGORY_DB_CONNECTION_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
	ON DELETE CASCADE
;
-- The two fields of CATEGORY_DB_CONNECTION are FKs
ALTER TABLE CATEGORY_DB_CONNECTION ADD CONSTRAINT FK_CATEGORY_DB_CONNECTION_DB_CONNECTION 
	FOREIGN KEY (CONNECTION_ID) REFERENCES DB_CONNECTION (CONNECTION_ID)
	ON DELETE CASCADE
;
-- The two fields of CATEGORY_USER are FKs
ALTER TABLE CATEGORY_USER ADD CONSTRAINT FK_CATEGORY_USER_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
	ON DELETE CASCADE
;
-- The two fields of CATEGORY_USER are FKs
ALTER TABLE CATEGORY_USER ADD CONSTRAINT FK_CATEGORY_USER_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_DATASET are FKs
ALTER TABLE DATAFLOW_DATASET ADD CONSTRAINT FK_DATAFLOW_DATASET_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_DATASET are FKs
ALTER TABLE DATAFLOW_DATASET ADD CONSTRAINT FK_DATAFLOW_DATASET_DATASET 
	FOREIGN KEY (DS_ID) REFERENCES DATASET (DS_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_DB_CONNECTION are FKs
ALTER TABLE DATAFLOW_DB_CONNECTION ADD CONSTRAINT FK_DATAFLOW_DB_CONNECTION_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_DB_CONNECTION are FKs
ALTER TABLE DATAFLOW_DB_CONNECTION ADD CONSTRAINT FK_DATAFLOW_DB_CONNECTION_DB_CONNECTION 
	FOREIGN KEY (CONNECTION_ID) REFERENCES DB_CONNECTION (CONNECTION_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_USER are FKs
ALTER TABLE DATAFLOW_USER ADD CONSTRAINT FK_DATAFLOW_USER_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
	ON DELETE CASCADE
;
-- The two fields of DATAFLOW_USER are FKs
ALTER TABLE DATAFLOW_USER ADD CONSTRAINT FK_DATAFLOW_USER_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
	ON DELETE CASCADE
;
-- New field of DB_CONNECTION, the USER_ID is FK
ALTER TABLE DB_CONNECTION ADD CONSTRAINT FK_DB_CONNECTION_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
;

-- New field of MAPPING_SET, the USER_ID is FK
ALTER TABLE MAPPING_SET ADD CONSTRAINT FK_MAPPING_SET_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
;
-- New field of DATASET, the USER_ID is FK
ALTER TABLE DATASET ADD CONSTRAINT FK_DATASET_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
;


-- ******************************
--        HEADER CONSTRAINTS
-- ******************************

ALTER TABLE CONTACT_DETAIL ADD CONSTRAINT FK_CONTACT_DETAIL_CONTACT 
	FOREIGN KEY (CONTACT_ID) REFERENCES CONTACT (CONTACT_ID)
	ON DELETE CASCADE
;

ALTER TABLE CONTACT ADD CONSTRAINT FK_CONTACT_PARTY 
	FOREIGN KEY (PARTY_ID) REFERENCES PARTY (PARTY_ID)
	ON DELETE CASCADE
;

ALTER TABLE HEADER_LOCALISED_STRING ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_CONTACT 
	FOREIGN KEY (CONTACT_ID) REFERENCES CONTACT (CONTACT_ID)
	ON DELETE CASCADE
;

ALTER TABLE HEADER_LOCALISED_STRING ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_HEADER 
	FOREIGN KEY (HEADER_ID) REFERENCES HEADER (HEADER_ID)
	ON DELETE CASCADE
;

ALTER TABLE HEADER_LOCALISED_STRING ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_PARTY 
	FOREIGN KEY (PARTY_ID) REFERENCES PARTY (PARTY_ID)
	ON DELETE CASCADE
;

ALTER TABLE PARTY ADD CONSTRAINT FK_PARTY_HEADER 
	FOREIGN KEY (HEADER_ID) REFERENCES HEADER (HEADER_ID)
	ON DELETE CASCADE
;

ALTER TABLE HEADER ADD CONSTRAINT FK_HEADER_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
	ON DELETE CASCADE
;


ALTER TABLE TRANSCODING_CODELIST ADD CONSTRAINT FK_TRANSCODING_COD_TRANSCODING 
	FOREIGN KEY (TR_ID) REFERENCES TRANSCODING (TR_ID)
ON DELETE CASCADE
;

ALTER TABLE TRANSCODING_RULE ADD CONSTRAINT FK_TRANSCODING_RUL_TRANSCODING 
	FOREIGN KEY (TR_ID) REFERENCES TRANSCODING (TR_ID)
ON DELETE CASCADE
;

ALTER TABLE TRANSCODING_RULE_DSD_CODE ADD CONSTRAINT FK_TRR_D_TRANSCODING_R 
	FOREIGN KEY (TR_RULE_ID) REFERENCES TRANSCODING_RULE (TR_RULE_ID)
ON DELETE CASCADE
;

ALTER TABLE TRANSCODING_RULE_LOCAL_CODE ADD CONSTRAINT FK_TRANSCODING_RULE_LOCAL_CODE 
	FOREIGN KEY (LCD_ID) REFERENCES LOCAL_CODE (LCD_ID)
ON DELETE CASCADE
;

ALTER TABLE TRANSCODING_RULE_LOCAL_CODE ADD CONSTRAINT FK_TRR_L_TRANSCODING_R 
	FOREIGN KEY (TR_RULE_ID) REFERENCES TRANSCODING_RULE (TR_RULE_ID)
ON DELETE CASCADE
;


-- ********************************************************
--        DEFAULT VALUES for existind and new fields
-- ********************************************************
-- Categories and dataflows may belong to DB_CONNECTIONS, DATASETS and MA_USERS.
-- Since we only know about the existence of a user, the admin, everything will
-- be set to the admin.
INSERT INTO DB_VERSION (VERSION) VALUES ('2.0')
;
INSERT INTO MA_USER (USER_ID, USERNAME, PASSWORD, USER_TYPE) VALUES (1, 'admin', '', 1)
;
UPDATE DB_CONNECTION SET USER_ID = 1
;
UPDATE MAPPING_SET SET USER_ID = 1
;
UPDATE DATASET SET USER_ID = 1
;

